#include "breakpoint.h"


#ifndef NOMONITOR	// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //

////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
BPoint::BPoint( void )
{
	// u[N|Cg
	for( int i=0; i<NR_BP; i++ ) BP[i].Type = BP_NONE;
	ReqBreak = FALSE;
	ReqBPNum = 0;
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
BPoint::~BPoint( void ){}


////////////////////////////////////////////////////////////////
// u[N|Cg̗L`FbN
////////////////////////////////////////////////////////////////
BOOL BPoint::ExistBreakPoint( void )
{
	for( int i=0; i<NR_BP; i++ )
		if( BP[i].Type != BP_NONE ) return TRUE;
	
	return FALSE;
}


////////////////////////////////////////////////////////////////
// u[N|Cg`FbN
////////////////////////////////////////////////////////////////
BOOL BPoint::CheckBreakPoint( BPtype type, WORD addr, BYTE data, char *str )
{
	for( int i=0; i<NR_BP; i++ ){
		if( BP[i].Type == type && BP[i].Addr == addr ){
			BPNo   = i+1;
			BPAddr = addr;
			BPData = data;
			BPStr  = str;
			
			ReqBreak = TRUE;
			ReqBPNum = i;
			
			return TRUE;
		}
	}
	return FALSE;
}


////////////////////////////////////////////////////////////////
// u[N|Cg̏NA
////////////////////////////////////////////////////////////////
void BPoint::ClearStatus( void )
{
	BPNo   = BP_NONE;
	BPAddr = 0;
	BPData = 0;
	BPStr  = NULL;
}


////////////////////////////////////////////////////////////////
// u[N|Cg̃^Cv擾
////////////////////////////////////////////////////////////////
BPoint::BPtype BPoint::GetType( int num )
{
	return BP[num].Type;
}


////////////////////////////////////////////////////////////////
// u[N|Cg̃AhX擾
////////////////////////////////////////////////////////////////
WORD BPoint::GetAddr( int num )
{
	return BP[num].Addr;
}


////////////////////////////////////////////////////////////////
// u[N|Cg̃^Cvݒ
////////////////////////////////////////////////////////////////
void BPoint::SetType( int num, BPtype type )
{
	BP[num].Type = type;
}


////////////////////////////////////////////////////////////////
// u[N|Cg̃AhXݒ
////////////////////////////////////////////////////////////////
void BPoint::SetAddr( int num, WORD addr )
{
	BP[num].Addr = addr;
}


////////////////////////////////////////////////////////////////
// u[Nv?
////////////////////////////////////////////////////////////////
BOOL BPoint::IsReqBreak( void )
{
	return ReqBreak;
}


////////////////////////////////////////////////////////////////
// u[Nv̂u[N|CgNo.擾
////////////////////////////////////////////////////////////////
int BPoint::GetReqBPNum( void )
{
	return ReqBPNum;
}


////////////////////////////////////////////////////////////////
// u[NvLZ
////////////////////////////////////////////////////////////////
void BPoint::ResetBreak( void )
{
	ReqBreak = FALSE;
	ReqBPNum = 0;
}


#endif				// @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ //
