#ifndef GRAPH_H_INCLUDED
#define GRAPH_H_INCLUDED

#include "typedef.h"
#include "p6device.h"
#include "vsurface.h"



////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
class DSP6 : public P6DEVICE {
protected:
	VSurface *SBuf;			// Tuobt@|C^
	COLOR24 *Pal;			// pbgւ̃|C^
	int Bpp;				// J[[h
	int SLBr;				// XLCPx
	
	BOOL SetScreenSurface();				// XN[T[tFX쐬
	BOOL UpdateSubBuf();					// Tuobt@XV
	BOOL RefreshSubBuf();					// Tuobt@tbV
	
	void BlitToSDL( VSurface *, int, int );	// SDLT[tFXVSurfaceBlit
	void BlitToSDL2( VSurface *, int, int );	// SDLT[tFXVSurfaceBlit 2{

public:
	DSP6( VM6 *, const P6ID& );				// RXgN^
	~DSP6();								// fXgN^
	
	BOOL Init( int, int, COLOR24 * );		// 
	
	BOOL ResizeScreen();					// XN[TCYύX
	
	void DrawScreen();						// ʍXV
	void SnapShot( char * );				// XibvVbg
	
	int ScreenX();							// LXN[擾
	int ScreenY();							// LXN[擾
	
	VSurface *GetSubBuffer();				// Tuobt@擾
};


#endif	// GRAPH_H_INCLUDED
